import { Component, OnInit, ViewEncapsulation,Input} from '@angular/core';
import { ToasterService, ToasterConfig } from 'angular2-toaster';

@Component({
  selector: 'ace-toaster',
  templateUrl: './ace-toaster.component.html',
  styleUrls: ['./ace-toaster.component.scss'],
  encapsulation: ViewEncapsulation.None
})
export class AceToasterComponent implements OnInit {
  @Input() type:string = 'success';
  @Input() title:string;
  @Input() body:string;
  constructor(
    public toasterService: ToasterService
  ) { }
  public toasterconfig: ToasterConfig =
  new ToasterConfig({
    animation: 'fade', //动画
    showCloseButton: false,
    tapToDismiss: true,  //只有点击 x 的时候才能关闭
    timeout:{
      error:5000,
      success:5000,
      warning:5000,
      info:5000
    },  //延时关闭
    limit: 5, //数量
    newestOnTop: true
  });
  ngOnInit() {

  };
  
  open() {
    var option = {
      type: this.type,
      title:this.title,
      body:this.body,
    }
    this.toasterService.pop(option);
  };

}
