import { Component, OnInit, ViewEncapsulation, ViewChild } from '@angular/core';
// import '../../assets/js/jquery.jqGrid.min.js';
// import '../../assets/js/bootstrap-datepicker.min.js';
// import '../../assets/js/grid.locale-en.js'

var list = [{ id: "1", name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
{ id: "2", name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03" },
{ id: "3", name: "LCD Monitor", note: "note3", stock: "Yes", ship: "TNT", sdate: "2007-12-03" },
{ id: "4", name: "Speakers", note: "note", stock: "No", ship: "ARAMEX", sdate: "2007-12-03" },
{ id: "5", name: "Laser Printer", note: "note2", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
{ id: "6", name: "Play Station", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03" },
{ id: "7", name: "Mobile Telephone", note: "note", stock: "Yes", ship: "ARAMEX", sdate: "2007-12-03" },
{ id: "8", name: "Server", note: "note2", stock: "Yes", ship: "TNT", sdate: "2007-12-03" },
{ id: "9", name: "Matrix Printer", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03" },
{ id: "10", name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
{ id: "11", name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03" }]

@Component({
	selector: 'app-table-page',
	templateUrl: './table-page.component.html',
	styleUrls: ['./table-page.component.scss'],
	encapsulation: ViewEncapsulation.None
})
export class TablePageComponent implements OnInit {
	@ViewChild('table1') table1;
	//插槽
	public slotTH = [
		{
			name: 'select',
			text: '选择器'
		},
		{
			name: 'address',
			text: '插槽位置'
		},
		{
			name: 'detail',
			text: '备注'
		},
		{
			name: 'demo',
			text: '例子'
		},
	];
	public slotSource = [
		{
			select: '.tbHeader',
			address: '位于标题栏（前提是存在tbTitle）',
			detail: '一般添加一些刷新按钮等',
			demo: '<a href="#tbHeader">.tbHeader</a>',
		},
		{
			select: '.footer',
			address: '列表下方，翻页上方',
			detail: '一般用于合计之类的',
			demo: '<a href="#footer">.footer</a>',
		},
		{
			select: '< \nng-template>...< \n\\ng-template>',
			address: '位于td内部',
			detail: `一般用于添加自定义标签（需要绑定事件那种），添加这种标签，会让每个td都存在该插槽，
			需要配合 <p class="text-danger">样式去实现控制，因此不建议，添加复杂的功能，否则可能出现性能问题。</p>
			<p class='text-info'>一般的使用方法  { operate: { slot:true } }</p>，operate那一列就会添加模板`,
			demo: ' - ',
		},
	]
	getSlotKeys(item) {
		return [item.select, item.address, item.detail, item.demo]
	}

	//自动化
	public autoTH = [
		{
			name: 'name',
			text: '属性'
		},
		{
			name: 'type',
			text: '类型'
		},
		{
			name: 'detail',
			text: '备注'
		},
		{
			name: 'demo',
			text: '例子'
		},
	];
	public autoSource = [
		{
			name: 'ajaxUrl',
			type: 'string',
			detail: '请求的地址',
			demo: ' - ',
		},
		{
			name: 'setParamsFn',
			type: 'function',
			detail: `发送请求前调用的函数，返回的值为请求参数
			<p class='text-danger'>return {</p>
			<p class='text-danger mgl-16'>method:'get/post/put/delete',</p>
			<p class='text-danger mgl-16'>headers:{...},</p>
			<p class='text-warning mgl-16'>url:'可选',</p>
			<p class='text-danger mgl-16'>data:'发送的参数',</p>
			<p class='text-danger'>}</p>
			`,
			demo: ' - ',
		},
		{
			name: 'cbParams',
			type: 'object',
			detail: `非常重要，该部分是请求回来后，遍历返回对象，赋值规定的字段,
			<p class='text-danger'>{</p>
			<p class='text-danger mgl-16'>code:'状态码字段',</p>
			<p class='text-danger mgl-16'>page:'当前页字段',</p>
			<p class='text-danger mgl-16'>total:'总数字段',</p>
			<p class='text-danger mgl-16'>items:'列表字段',</p>
			<p class='text-warning mgl-16'>message:'（可选）用于失败请求时候，返回的错误信息'</p>
			<p class='text-danger'>}</p>`,
			demo: `<p class='text-info'>{</p>
			<p class='text-info mgl-16'>code:'code',</p>
			<p class='text-info mgl-16'>page:'currPage',</p>
			<p class='text-info mgl-16'>total:'total',</p>
			<p class='text-info mgl-16'>items:'list',</p>
			<p class='text-info mgl-16'>message:'msg'</p>
			<p class='text-info'>}</p>`,
		},
		{
			name: 'onAjaxOver (自定义事件)',
			type: 'function',
			detail: '<p class="text-info">请求完成后触发，用于，对数据进行二次处理，例如，添加td的插槽',
			demo: ' - ',
		},
		{
			name: `<p class="text-danger">@ViewCild('table') table; table.sendAjax(<span class='text-info'>page:number</span>)</p>`,
			type: 'function',
			detail: '手动控制发送请求，作用于点击搜索后，触发该函数',
			demo: ' - ',
		}
	]
	getAutoKeys(item) {
		return [item.name, item.type, item.detail, item.demo]
	}
	proTable = {
		th: ['属性', '说明', '类型', "Demo", '默认值'],
		tbody: [
			{
				name: 'tbTitle',
				text: '表格标题',
				type: 'string',
				demo: " - ",
				default: ' - '
			},
			{
				name: 'operateState',
				text: '是否开启控制开关栏',
				type: 'boolean',
				demo: ` - `,
				default: ' false '
			}, {
				name: 'changeState',
				text: '是否开启操作栏',
				type: 'boolean',
				demo: ` - `,
				default: ' false '
			},
			{
				name: 'dataSource',
				text: '表格遍历的数据，每一个对象的 key 值对应着theadSource 数据的name值',
				type: 'Array<object>',
				demo: `[{id:"11"}]`,
				default: ' - '
			},
			{
				name: 'theadSource',
				text: '表头遍历的数据',
				type: 'Array<object>',
				demo: "[{name:'id',text:'编号'}]",
				default: ' - '
			},
			{
				name: 'widths',
				text: '设置每一列的宽度',
				type: 'Array<number>',
				demo: "[200,200]",
				default: '[ ]'
			},
			{
				name: 'minWidth',
				text: '每一列的最小宽度',
				type: 'number',
				demo: " - ",
				default: '100'
			},
			{
				name: 'tableHeight',
				text: '表格的高度，设置了就会出现滚动条，最小为 150px',
				type: 'number',
				demo: " - ",
				default: '- '
			},
			{
				name: 'loading',
				text: '加载动画',
				type: 'boolean',
				demo: " - ",
				default: 'false '
			},
			{
				name: 'multipleChoice',
				text: '是否出现多选框',
				type: 'boolean',
				demo: " - ",
				default: ' true'
			},
			{
				name: 'dataInf',
				text: `列表相关数据 , 如果不填就是 X<br>
				{<br>
					 &nbsp;&nbsp; page:number;  <i>//当前页码</i><br>   
					  &nbsp;&nbsp; totalPage?:number;<i>//全部页数</i><br>
					  &nbsp;&nbsp; total?:number;<i>//数据总数</i><br>
					  &nbsp;&nbsp; startId?:number;<i>//当前页开始数据的id</i><br>
					  &nbsp;&nbsp; endId?:number;<i>//当前页最后数据的id</i><br>
					}
				`,
				type: 'object',
				demo: " - ",
				default: `{<br>
						page:1,<br>
				    totalPage:1,<br>
				    total:10,<br>
				    startId:1,<br>
				    endId:10<br>}`
			},
			{
				name: 'modalState',
				text: `设置modal 相关配置<br>
				{<br>
					 &nbsp;&nbsp; show:boolean; <i>//modal状态</i><br>
  				 &nbsp;&nbsp; text?:string; <i>//文字 </i><br>
					}
				`,
				type: 'object',
				demo: `{<br>
					&nbsp;&nbsp; show:true,<br>
					&nbsp;&nbsp; text:'无更多数据'<br>
				}`,
				default: '{show:false}'
			},
			{
				name: 'paginNum',
				text: '翻页器显示的数量',
				type: 'number',
				demo: " - ",
				default: ' 5 '
			}
		]
	};
	eventTable = {
		th: ['事件', '说明', '返回类型'],
		tbody: [
			{
				event: 'onSelect',
				text: "<b>multipleChoice 为 true 才能触发</b> , 勾选了多选框，或者选择了全选 , 返回的是整行数据",
				type: 'Array<object>'
			},
			{
				event: 'onChangeRows',
				text: "更改了每页显示的行数时候触发",
				type: 'number'
			},
			{
				event: 'onChangePage',
				text: "翻页时候触发",
				type: 'number'
			},
			{
				event: 'onReflresh',
				text: "刷新单项",
				type: ' object '
			},
			{
				event: 'onShowDetail',
				text: "非自定义事件，该事件为点击展开时候触发，展示的数据为 dataSource[idx].detail",
				type: 'number'
			}
		]
	};
	
	//相关属性
	
	relateTh=['属性','说明','类型',"Demo",'默认值'];
	relateProp = [
		{
			name: 'rowNumber',
			text: '展示的列表数量',
			type: 'number',
			demo: " - ",
			default: ' 10 '
		}
	]


	constructor() { }
	demo4 = {
		tbTitle: 'Demo1 设置前6列的的宽度为200',
		widths: [100, 100, 100, 100, 100],
		dataSource: [
			{ id: "<b>1</b>", name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03", detail: "我是细节1" },
			{ id: "2", name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03", detail: "我是细节2" },
			{ id: "3", name: "LCD Monitor", note: "note3", stock: "Yes", ship: "TNT", sdate: "2007-12-03", detail: "我是细节3" },
			{ id: "4", name: "Speakers", note: "note", stock: "No", ship: "ARAMEX", sdate: "2007-12-03", detail: "我是细节4" },
			{ id: "5", name: "Laser Printer", note: "note2", stock: "Yes", ship: "FedEx", sdate: "2007-12-03", detail: "我是细节5" },
			{ id: "6", name: "Play Station", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03", detail: "我是细节6" },
			{ id: "7", name: "Mobile Telephone", note: "note", stock: "Yes", ship: "ARAMEX", sdate: "2007-12-03", detail: "我是细节7" },
			{ id: "8", name: "Server", note: "note2", stock: "Yes", ship: "TNT", sdate: "2007-12-03", detail: "我是细节8" },
			{ id: "9", name: "Matrix Printer", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03", detail: "我是细节0" },
			{ id: "10", name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03", detail: "我是细节11" },
			{ id: "11", name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03", detail: "我是细节12" },
		],
		modalState: {
			show: false,
			text: '初次打开页面不加载数据，请组合条件进行搜索数据...'
		},
		dataInf: {
			page: 1,
			totalPage: 3,
			total: 32,
			startId: 1,
			endId: 10
		},
		loading: false,
		rowNumber: 10
	};
	demo1 = {
		tbTitle: 'Demo2 提示框',
		widths: [],
		dataSource: [],
		modalState: {
			show: true,
			text: '初次打开页面不加载数据，请组合条件进行搜索数据...'
		}
	};
	demo2 = {
		tbTitle: 'Demo3 不设置表格高度tableHeight',
		widths: [],
		dataSource: [
			{ id: { rowspan: 3, value: 1 }, name: { value: '测试', rowspan: 3 }, note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03" },
			{ note: "note3", stock: "Yes", ship: "TNT", sdate: "2007-12-03" },
			{ id: { value: "2", rowspan: 8 }, name: "Speakers", note: "note", stock: "No", ship: "ARAMEX", sdate: "2007-12-03" },
			{ name: "Laser Printer", note: "note2", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ name: "Play Station", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03" },
			{ name: "Mobile Telephone", note: "note", stock: "Yes", ship: "ARAMEX", sdate: "2007-12-03" },
			{ name: "Server", note: "note2", stock: "Yes", ship: "TNT", sdate: "2007-12-03" },
			{ name: "Matrix Printer", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03" },
			{ name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03" },
		],
		modalState: {
			show: false,
			text: '初次打开页面不加载数据，请组合条件进行搜索数据...'
		}
	};
	demo3 = {
		tbTitle: 'Demo4 设置表格宽度tableHeight  最小值为150 ',
		widths: [],
		dataSource: [
			{ id: "1", name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "2", name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03" },
			{ id: "3", name: "LCD Monitor", note: "note3", stock: "Yes", ship: "TNT", sdate: "2007-12-03" },
			{ id: "4", name: "Speakers", note: "note", stock: "No", ship: "ARAMEX", sdate: "2007-12-03" },
			{ id: "5", name: "Laser Printer", note: "note2", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "6", name: "Play Station", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "7", name: "Mobile Telephone", note: "note", stock: "Yes", ship: "ARAMEX", sdate: "2007-12-03" },
			{ id: "8", name: "Server", note: "note2", stock: "Yes", ship: "TNT", sdate: "2007-12-03" },
			{ id: "9", name: "Matrix Printer", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "10", name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "11", name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03" },
		],
		modalState: {
			show: false,
			text: '初次打开页面不加载数据，请组合条件进行搜索数据...'
		}
	};

	demo5 = {
		tbTitle: 'Demo5 不要选择框 [multipleChoice]',
		widths: [],
		multipleChoice: false,
		dataSource: [
			{ id: "1", name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "2", name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03" },
			{ id: "3", name: "LCD Monitor", note: "note3", stock: "Yes", ship: "TNT", sdate: "2007-12-03" },
			{ id: "4", name: "Speakers", note: "note", stock: "No", ship: "ARAMEX", sdate: "2007-12-03" },
			{ id: "5", name: "Laser Printer", note: "note2", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "6", name: "Play Station", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "7", name: "Mobile Telephone", note: "note", stock: "Yes", ship: "ARAMEX", sdate: "2007-12-03" },
			{ id: "8", name: "Server", note: "note2", stock: "Yes", ship: "TNT", sdate: "2007-12-03" },
			{ id: "9", name: "Matrix Printer", note: "note3", stock: "No", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "10", name: "Desktop Computer", note: "note", stock: "Yes", ship: "FedEx", sdate: "2007-12-03" },
			{ id: "11", name: "Laptop", note: "Long text ", stock: "Yes", ship: "InTime", sdate: "2007-12-03" },
		]
	};
	theadSource = [
		{ name: 'id', text: '编号' },
		{ name: 'name', text: '名字' },
		{ name: 'note', text: '笔记' },
		{ name: 'stock', text: 'stock' },
		{ name: 'ship', text: '邮寄方式' },
		{ name: 'sdate', text: '时间' }
	];




	getKeys(item: any) {
		return [item.name, item.text, item.type, item.demo, item.default]
	}
	getEventKeys(item: any) {
		return [item.event, item.text, item.type]
	}
	selectedRow = [];
	mySelector(e: any) {
		this.selectedRow = e;
	}

	ngOnInit() {
		setTimeout(() => {
			this.table1.sendAjax(1);
		}, 500)

	}

	//demo4换页
	changeDemo4Page(page: number) {
		var arr = [];
		this.demo4.dataInf.page = page;
		this.demo4.loading = true;

		if (page < 3) {
			for (var i = 0; i < this.demo4.rowNumber; i++) {
				let obj = JSON.parse(JSON.stringify(list[Math.floor(Math.random() * 10)]));
				obj.id = (page - 1) * this.demo4.rowNumber + i + 1;
				arr.push(obj);
			}
		} else {
			for (var i = 0; i < 2; i++) {
				let obj = JSON.parse(JSON.stringify(list[Math.floor(Math.random() * 10)]));
				obj.id = (page - 1) * this.demo4.rowNumber + i + 1;
				arr.push(obj);
			}
		}


		setTimeout(() => {
			this.demo4.dataSource = arr;
			this.demo4.loading = false;
			this.demo4.dataInf.startId = (page - 1) * this.demo4.rowNumber + 1;
			this.demo4.dataInf.endId = (page - 1) * this.demo4.rowNumber + arr.length;
		}, 1000)
	}

	//demo4 换显示数量
	changeDemo4Rows(num: number) {
		if (this.demo4.rowNumber != num) {
			this.demo4.rowNumber = num;
			this.changeDemo4Page(this.demo4.dataInf.page)
		}
	};


	//自动化
	autoHeader = [
		{
			name: 'original_country',
			text: '国家'
		},
		{
			name: 'operate',
			text: '操作'
		},
		{
			name: 'stayTimeLength',
			text: '停留时间'
		},
		{
			name: 'detail',
			text: '查看'
		},
	];

	cbParams = {
		code: 'code',
		items: 'items',
		page: 'page',
		total: 'total'
	};

	tableSettingParams() {
		return {
			method: 'get',
			data: {

			}
		}
	};

	onAjaxOver(){
		this.table1.modalState.show = false;
		this.table1.dataSource=[{
			original_country:'china',
			operate:{
				slot:true,
				value:'i am value'
			},
			stayTimeLength:'1天',
			detail:{
				slot:true
			}
		}]
		console.log('sendAjax')
	}
	
	modalState={
		show:false,
		title:'自动化',
	}
	
	slotBtnClicked(){
		this.modalState.show = true;
	}
}
